/**
 *
 * Written by Ed Hong UWT Feb. 19, 2003
// based on code in Goodrich & Tamassia's Algorithm Design,
// page 332
 *
 * @author edhong
 * @version 0.0
 */


/** This class specializes DFS to determine whether the graph is connected. */
public class ConnectivityTesterDFS extends DFS {
  protected int num_reached; // tracks number of vertices reached.

  public void startVisit(Vertex v) { num_reached++; }

	// Main algorithm to determine connectedness.
  public boolean isConnected(SimpleGraph G) {
	  Vertex v;
	num_reached = 0;
	v = G.aVertex(); // start at some vertex
	execute(G,v);    // do a dfs search
	return (num_reached == G.numVertices()); // did I reach all the nodes?
  }
}
