/**
 *
 * Written by Ed Hong UWT Feb. 19, 2003
// based on code in Goodrich & Tamassia's Algorithm Design,
// page 333
 *
 * @author edhong
 * @version 0.0
 */

 import java.util.*;

/** This class specializes DFS to find a path between the start vertex
  * and a given target vertex.  */
public class FindPathDFS extends DFS {
  protected LinkedList path;
  protected boolean done;
  protected Vertex target;

  /** returns list of Vertices representing path
      that was constructed in DFS traversal */
  public LinkedList findPath(SimpleGraph G, Vertex start, Vertex dest) {
	  // initialize things.
  	  target = dest;
	  done = false;
	  path = new LinkedList();

	  // do the dfs
	  execute(G,start);

	  // return result
	  return path;
  }

  protected void startVisit(Vertex v) {
    path.addLast(v);
    if (v == target)   // found the target; we have a path!
      done = true;
  }
  protected void finishVisit(Vertex v) {
    if (!done)            // don't remove vertex if a path was found and
      path.removeLast();  // we are in the process of returning..
  }
  protected boolean isDone() {
    return done;
  }

}
